#!/usr/bin/perl
# create_virt.cgi
# Create a new virtual host.

require './apache-lib.pl';
&ReadParse();
$access{'create'} || &error($text{'cvirt_ecannot'});
&error_setup($text{'cvirt_err'});
$conf = &get_config();

# Validate inputs
if ($in{'addr_def'}) {
	if ($httpd_modules{'core'} >= 1.2) { $addr = "_default_"; }
	else { $addr = "*"; }
	}
elsif ($in{'addr'} !~ /\S/) { &error($text{'cvirt_eaddr1'}); }
elsif (!gethostbyname($in{'addr'}) && !&check_ipaddress($in{'addr'}) &&
       $in{'addr'} ne '*')
	{ &error(&text('cvirt_eaddr2', $in{'addr'})); }
else { $addr = $in{'addr'}; }

if ($in{'port_mode'} == 0) { $port = ""; }
elsif ($in{'port_mode'} == 1) { $port = ":*"; }
elsif ($in{'port'} !~ /^\d+$/) { &error(&text('cvirt_eport', $in{'port'})); }
else { $port = ":$in{'port'}"; }
if (!$in{'name_def'} && $in{'name'} !~ /^\S+$/) {
	&error(&text('cvirt_ename', $in{'name'}));
	}

# Check if the virtual server already exists
if ($in{'name_def'}) {
	$aclname = "$addr$port";
	}
else {
	$aclname = "$in{'name'}$port";
	}
@virt = &find_directive_struct("VirtualHost", $conf);
foreach $v (@virt) {
	if (&virt_acl_name($v) eq $aclname) {
		&error($text{'cvirt_etaken'});
		}
	}

if ($in{'root'} && !-d $in{'root'}) {
	# create the document root
	mkdir($in{'root'}, 0755) ||
		&error(&text('cvirt_eroot2', $in{'root'}, $!));
	$user = &find_directive("User", $conf);
	$group = &find_directive("Group", $conf);
	$uid = $user ? getpwnam($user) : 0;
	$gid = $group ? getgrnam($group) : 0;
	chown($uid, $gid, $in{'root'});
	}

# find file to add to
$f = $config{'virt_file'};
if (!$f) {
	# use the first file in config (usually httpd.conf)
	$vconf = &get_virtual_config();
	$f = $vconf->[0]->{'file'};
	for($j=0; $vconf->[$j]->{'file'} eq $f; $j++) { }
	$l = $vconf->[$j-1]->{'eline'}+1;
	}

# add NameVirtualHost if needed
&lock_apache_files();
if ($in{'nv'} && !$in{'addr_def'}) {
	local $ip = &to_ipaddress($in{'addr'});
	local $found;
	local @nv = &find_directive("NameVirtualHost", $conf);
	foreach $nv (@nv) {
		$found++ if ($nv eq $ip);
		}
	if (!$found && $ip) {
		&save_directive("NameVirtualHost", [ @nv, $ip ], $conf, $conf);
		}
	}

$lref = &read_file_lines($f);
push(@$lref, "");
push(@$lref, "<VirtualHost $addr$port>");
push(@$lref, "DocumentRoot $in{'root'}") if ($in{'root'});
if (!$in{'name_def'}) {
	push(@$lref, "ServerName $in{'name'}");
	}
push(@$lref, "</VirtualHost>");
&flush_file_lines();
&unlock_apache_files();
&webmin_log("virt", "create", ($in{'name_def'} ? $addr : $in{'name'}).$port,
	    \%in);

# add to acl
if ($access{'virts'} ne '*') {
	$access{'virts'} .= " $aclname";
	&save_module_acl(\%access);
	}
&redirect("");

