#!/usr/bin/perl
# install_mod.cgi
# Download and install a webmin module

require './webmin-lib.pl';
if ($ENV{REQUEST_METHOD} eq "POST") { &ReadParseMime(); }
else { &ReadParse(); $no_upload = 1; }

if ($in{'source'} == 0) {
	# from local file
	&error_setup(&text('install_err1', $in{'file'}));
	$file = $in{'file'};
	if (!(-r $file)) { &inst_error($text{'install_efile'}); }
	}
elsif ($in{'source'} == 1) {
	# from uploaded file
	&error_setup($text{'install_err2'});
	$file = &tempname();
	$need_unlink = 1;
	if ($no_upload) {
                &inst_error($text{'install_ebrowser'});
                }
	open(MOD, "> $file");
	print MOD $in{'upload'};
	close(MOD);
	}
elsif ($in{'source'} == 2) {
	# from ftp or http url
	&error_setup(&text('install_err3', $in{'url'}));
	$file = &tempname();
	$need_unlink = 1;
	if ($in{'url'} =~ /^http:\/\/([^\/]+)(\/.*)$/) {
		$host = $1; $page = $2; $port = 80;
		if ($host =~ /^(.*):(\d+)$/) { $host = $1; $port = $2; }
		&http_download($host, $port, $page, $file);
		}
	elsif ($in{'url'} =~ /^ftp:\/\/([^\/]+)\/(.*)$/) {
		$host = $1; $ffile = $2;
		&ftp_download($host, $ffile, $file);
		}
	else { &inst_error($text{'install_eurl'}); }
	}

# Install the module(s)
$redirect_to = &install_webmin_module($file, $need_unlink, \@mdescs, \@mdirs,
				      \@msizes, $in{'nodeps'});

if ($in{'redirect'}) {
	# Redirect to the new module
	&redirect("/$redirect_to/");
	}
else {
	# Display something nice for the user
	&header($text{'install_title'}, "");
	print "<hr>\n";
	print "$text{'install_desc'} <p>\n";
	print "<ul>\n";
	for($i=0; $i<@mdescs; $i++) {
		print &text('install_line', "<b>$mdescs[$i]</b>",
			    "<tt>$mdirs[$i]</tt>", $msizes[$i]),"<p>\n";
		}
	print "</ul><p>\n";
	print "<hr>\n";
	&footer("", $text{'index_return'});
	}

sub inst_error
{
if ($need_unlink) { unlink($file); }
&error(@_);
}

